//+------------------------------------------------------------------+
//|                                                      BW-Zone.mq4 |
//|                                              2009, SVK Software |
//|                                                                  |
//+------------------------------------------------------------------+
//mod2009fxtsd

#property copyright " 2009, SVK Software"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 Gray
#property indicator_color4 Gray

#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1

//---- buffers
double UpBuffer1[];
double DnBuffer1[];
double UpBuffer3[];
double DnBuffer3[];
double macdBuff[];
double sigBuff[];
double osmaBuff[];

extern int    Fast_MA      = 5;
extern int    Slow_MA      = 34;
extern int    Sig_MA       = 5;

extern int    Fast_MA_Method      = 0;
extern int    Slow_MA_Method      = 0;
extern int    Sig_MA_Method       = 0;

extern int    Fast_MA_Price      = 4;
extern int    Slow_MA_Price      = 4;

extern string   note_Price = "0C 1O 2H 3L 4Md 5Tp 6WghC: Md(HL/2)4,Tp(HLC/3)5,Wgh(HLCC/4)6";
extern string   MA_Method_ = "SMA0 EMA1 SMMA2 LWMA3";



int    BarsCount;
int    Length = 100;
int    limit;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

   IndicatorBuffers(7);

   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,UpBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,DnBuffer1);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(2,UpBuffer3);
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(3,DnBuffer3);

   SetIndexBuffer(4,macdBuff);
   SetIndexBuffer(5,sigBuff);
   SetIndexBuffer(6,osmaBuff);

   for(int b=0;b<=indicator_buffers;b++) SetIndexDrawBegin (b,Slow_MA);


//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   int limit,i;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
            limit=Bars-counted_bars-1;
            
            
            
    for(i=limit;i>=0;i--) 
         macdBuff[i]=iMA(NULL,0,Fast_MA,0,Fast_MA_Method,Fast_MA_Price,i)-
                     iMA(NULL,0,Slow_MA,0,Slow_MA_Method,Slow_MA_Price,i);
           
            
    for(i=limit;i>=0;i--)
        { 
         sigBuff[i]=iMAOnArray(macdBuff,0,Sig_MA,0,Sig_MA_Method,i);
         osmaBuff[i]=macdBuff[i]-sigBuff[i];
        }
           
                         
    for(i=limit;i>=0;i--) 
    {
      
       UpBuffer1[i] =EMPTY_VALUE;
       DnBuffer1[i] =EMPTY_VALUE;
       UpBuffer3[i] =EMPTY_VALUE;
       DnBuffer3[i] =EMPTY_VALUE;

       if (macdBuff[i] > macdBuff[i+1] && osmaBuff[i] > osmaBuff[i+1])
         {
          UpBuffer1[i] = High[i];
          DnBuffer1[i] = Low[i];
         }
       
       else   
       if (macdBuff[i] < macdBuff[i+1] && osmaBuff[i] < osmaBuff[i+1])
         {
          UpBuffer1[i] = Low[i];
          DnBuffer1[i] = High[i];
         }
       
       else   
         {
          UpBuffer3[i] = High[i];
          DnBuffer3[i] = Low[i];
         }
      } 
//----//
   return(0);
  }
//+------------------------------------------------------------------+